﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Test
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            this.ViewModel.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(ViewModel_PropertyChanged);
        }

        void ViewModel_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            switch (e.PropertyName)
            {
                case "Workspace":
                    this.InspectVisualTree();
                    break;
            }
        }

        private void InspectVisualTree()
        {
            DependencyObject view = (DependencyObject)this.WorkspacePresenter.Template.FindName("PART_WorkspaceContainer", this.WorkspacePresenter);

            if (view != null && view is FrameworkElement)
            {
                ((FrameworkElement)view).ApplyTemplate();

                //
                // Do stuff with the visual tree.
                //
            }
        }

        private ViewModel ViewModel
        {
            get { return (ViewModel)this.DataContext; }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            this.ViewModel.ChangeWorkspace();
        }
    }
}
